---
- name: Download Vault
  ansible.builtin.unarchive:
    src: "https://releases.hashicorp.com/vault/{{ vault_version }}/vault_{{ vault_version }}_linux_amd64.zip"
    dest: /usr/bin
    mode: '0755'
    remote_src: yes

- name: Create configuration directory
  file:
    path: /etc/vault-agent
    state: directory
    owner: root

- name: Upload systemd configuration
  copy:
    src: "{{ item }}"
    dest: /etc/systemd/system
  loop:
    - vault-agent.path
    - vault-agent.service

- name: Create systemd drop-in directory
  ansible.builtin.file:
    path: /etc/systemd/system/vault-agent.d
    state: directory
    owner: root

- name: Enable Vault Agent service
  ansible.builtin.systemd:
    state: stopped
    enabled: yes
    name: "{{ item }}"
  loop:
    - vault-agent.path
    - vault-agent.service
